Smart Proxy - Bug #2209

JSON output changes when ActiveRecord storeconfigs is in use
Assignee: Dominic Cleal

Category: API
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Pull request:

Description

When Puppet is configured with ActiveRecord-based storeconfigs, this causes the to_json impl from ActiveSupport to get loaded
over the 'json' gem implementation.

This causes a different APl output for Puppet environments, e.g.
$ curl http://192.168.122.90:8443/puppet/environments

[{"name":"test", "paths": ["/etc/puppet/modules"]}, {"name" : "production", "paths": ["/etc/puppet/module
s"1}]

vs the normal:

$ curl -k https://192.168.101.10:8443/puppet/environments
["development", "production"]

And then Foreman itself can't understand the data structure when importing classes:

undefined method “values' for []:Array

Associated revisions

Revision 603d0651 - 03/10/2013 09:44 AM - Dominic Cleal

fixes #2209 - explicitly use Proxy::Puppet::Environment#name for to_json

History

#1 - 03/07/2013 05:09 AM - Dominic Cleal
- Status changed from New to Ready For Testing

- Target version set to 26

https://github.com/theforeman/smart-proxy/pull/69

#2 - 03/13/2013 03:49 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 603d065154628361c104a46afce458d4ce22d639.

#3 - 05/10/2013 09:04 AM - Dominic Cleal

- Target version changed from 26 to 1.2.0

#4 - 10/15/2014 03:34 PM - Suyash Jain
Hi,

05/17/2024 1/2



https://github.com/theforeman/smart-proxy/pull/69
https://projects.theforeman.org/projects/smart-proxy/repository/7/revisions/603d065154628361c104a46afce458d4ce22d639

| am getting the same issue.
Oops, we're sorry but something went wrong

Warning!
undefined method “values' for []:Array

If you feel this is an error with Foreman itself, please open a new issue with Foreman ticketing system, You would probably need to attach the Full
trace and relevant log entries.

NoMethodError

undefined method “values' for []:Array

app/services/puppet_class_importer.rb:78:in ‘new_classes_for'
app/services/puppet_class_importer.rb:39:in “changes'
app/controllers/concerns/foreman/controller/environments.rb:11:in “import_environments'
app/models/concerns/foreman/thread_session.rb:33:in “clear_thread'
lib/middleware/catch_json_parse_errors.rb:9:in “call'

Regards

Suyash

#5 - 07/10/2018 02:45 PM - Greg Sutcliffe
- Target version deleted (1.2.0)
